#! /usr/bin/python
# Authors : Comminity at www.compiz.net 
import os, re
import pygtk
pygtk.require('2.0')

import gtk, gobject
import egg.trayicon

std_decorators = {'gnome':'metacity', 'kde':'kwin', 'xfce':'xfwm4'} # Support decorators when not using compiz
processes=os.popen("ps -A").read() # Get current processes
	
def fallback_decorator():
	if re.search(r"gnome-session\b", processes):
		gobject.spawn_async(['metacity', '--replace', 'gconf'], \
			flags=gobject.SPAWN_SEARCH_PATH)

	elif re.search(r"dcop\b", processes):
			gobject.spawn_async(['kwin', '--replace'], \
					     flags=gobject.SPAWN_SEARCH_PATH)
						 
#Need to add xfce, how do we find out if xfce is running?

if re.search(r"Xgl\b", processes):
	# If Xgl is running
	def start_decorator_default():
		if os.path.exists("/usr/bin/cgwd"):
			gobject.spawn_async(['cgwd', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			gobject.spawn_async(['compiz', '--replace', 'dbus', 'csm'], \
				flags=gobject.SPAWN_SEARCH_PATH)
		elif os.path.exists("/usr/lib/compiz/libcsm.so"):
			gobject.spawn_async(['gnome-window-decorator', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			gobject.spawn_async(['compiz', '--replace', 'dbus', 'csm'], \
				flags=gobject.SPAWN_SEARCH_PATH)
		elif os.path.exists("/usr/lib/compiz/libgconf.so"):
			gobject.spawn_async(['gnome-window-decorator', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			gobject.spawn_async(['compiz', '--replace', 'gconf'], \
				flags=gobject.SPAWN_SEARCH_PATH)
		else:
			fallback_decorator()
					
	def start_compiz_gwd():
		try:
			gobject.spawn_async(['gnome-window-decorator', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			gobject.spawn_async(['compiz', '--replace', 'dbus', 'csm'], \
				flags=gobject.SPAWN_SEARCH_PATH)
		except gobject.GError:
			gobject.spawn_async(['gnome-window-decorator', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			gobject.spawn_async(['compiz', '--replace', 'gconf'], \
				flags=gobject.SPAWN_SEARCH_PATH)
	
	def start_compiz_cgwd():
		gobject.spawn_async(['cgwd', '--replace'], \
			flags=gobject.SPAWN_SEARCH_PATH)
		gobject.spawn_async(['compiz', '--replace', 'dbus', 'csm'], \
			flags=gobject.SPAWN_SEARCH_PATH)	

else:
	def start_decorator_default():
		if os.path.exists("/usr/bin/cgwd"):
			gobject.spawn_async(['cgwd', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			os.environ['LIBGL_ALWAYS_INDIRECT'] = 'TRUE'
			gobject.spawn_async(['compiz', '--strict-binding', '--indirect-rendering', '--replace', 'dbus', 'csm'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			del os.environ['LIBGL_ALWAYS_INDIRECT']
		elif os.path.exists("/usr/lib/compiz/libcsm.so"):
			gobject.spawn_async(['gnome-window-decorator', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			os.environ['LIBGL_ALWAYS_INDIRECT'] = 'TRUE'
			gobject.spawn_async(['compiz', '--strict-binding', '--indirect-rendering', '--replace', 'dbus', 'csm'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			del os.environ['LIBGL_ALWAYS_INDIRECT']
		elif os.path.exists("/usr/lib/compiz/libgconf.so"):
			gobject.spawn_async(['gnome-window-decorator', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			os.environ['LIBGL_ALWAYS_INDIRECT'] = 'TRUE'
			gobject.spawn_async(['compiz', '--strict-binding', '--indirect-rendering', '--replace', 'gconf'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			del os.environ['LIBGL_ALWAYS_INDIRECT']
		else:
			fallback_decorator()			

	def start_compiz_gwd():
		try:
			gobject.spawn_async(['gnome-window-decorator', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			os.environ['LIBGL_ALWAYS_INDIRECT'] = 'TRUE'
			gobject.spawn_async(['compiz', '--strict-binding', '--indirect-rendering', '--replace', 'dbus', 'csm'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			del os.environ['LIBGL_ALWAYS_INDIRECT']	
		except gobject.GError:
			gobject.spawn_async(['gnome-window-decorator', '--replace'], \
				flags=gobject.SPAWN_SEARCH_PATH)
			gobject.spawn_async(['compiz', '--strict-binding', '--indirect-rendering', '--replace', 'gconf'], \
				flags=gobject.SPAWN_SEARCH_PATH)
		
	def start_compiz_cgwd():
		gobject.spawn_async(['cgwd', '--replace'], \
			flags=gobject.SPAWN_SEARCH_PATH)
		gobject.spawn_async(['compiz', '--strict-binding', '--indirect-rendering', '--replace', 'dbus', 'csm'], \
			flags=gobject.SPAWN_SEARCH_PATH)

def place_menu(menu):
	(width, height) = menu.size_request()
	(menu_xpos, menu_ypos) = tray.window.get_origin()
	menu_xpos = menu_xpos + tray.allocation.x
        menu_ypos = menu_ypos + tray.allocation.y
	if menu_ypos > tray.get_screen().get_height() / 2:
                menu_ypos -= height + 1
        else:
                menu_ypos += tray.allocation.height + 1

        x = menu_xpos;
        y = menu_ypos;
        push_in = True;
	return (x, y, push_in)

def configure_menu_activate(widget):
	if os.path.exists("/usr/bin/csm"):
		gobject.spawn_async(['csm'], flags=gobject.SPAWN_SEARCH_PATH)
	else:
		gobject.spawn_async(['gconf-editor'], flags=gobject.SPAWN_SEARCH_PATH)

def compiz_menu_activate(widget):
	start_compiz_gwd()

def metacity_menu_activate(widget):
	gobject.spawn_async(['metacity', '--replace'], \
			     flags=gobject.SPAWN_SEARCH_PATH)

def kwin_menu_activate(widget):
	gobject.spawn_async(['kwin', '--replace'], \
			     flags=gobject.SPAWN_SEARCH_PATH)

def cgwd_menu_activate(widget):
	start_compiz_cgwd()


def quit_menu_activate(widget):
	gtk.main_quit()

def callback(widget, ev):
	menu.set_screen(widget.get_screen())
	menu.popup(None, None, place_menu, ev.button, ev.time)

def gcompizthemer_menu_activate(widget):
	gobject.spawn_async(['gcompizthemer'], flags=gobject.SPAWN_SEARCH_PATH)


def kiba_menu_toggled(widget):		
	if widget.active :
		gobject.spawn_async(['kiba-dock'], flags=gobject.SPAWN_SEARCH_PATH)
	else:
		os.system("killall kiba-dock")
		
menu = gtk.Menu()
item = gtk.ImageMenuItem(stock_id=gtk.STOCK_PREFERENCES)
item.connect("activate", configure_menu_activate)
menu.append(item)
item = gtk.ImageMenuItem( "Theme Selector" )
item.connect("activate", gcompizthemer_menu_activate)
_img = gtk.Image()
_img.set_from_stock("gtk-select-color", gtk.ICON_SIZE_BUTTON)
item.set_image(_img)
menu.append(item)
item = gtk.SeparatorMenuItem()
menu.append(item)
item = gtk.MenuItem("Gnome Window Decorator")
item.connect("activate", compiz_menu_activate)
menu.append(item)
item = gtk.MenuItem("Compiz Window Decorator")
item.connect("activate", cgwd_menu_activate)
menu.append(item)
item = gtk.MenuItem("Metacity")
item.connect("activate", metacity_menu_activate)
menu.append(item)
item = gtk.MenuItem("Kwin")
item.connect("activate", kwin_menu_activate)
menu.append(item)
item = gtk.SeparatorMenuItem()
menu.append(item)
if os.path.exists("/usr/bin/kiba-dock"):
	item = gtk.CheckMenuItem("Kiba-Dock")
	item.connect("toggled", kiba_menu_toggled)
	menu.append(item)
	item = gtk.SeparatorMenuItem()
	menu.append(item)
	item = gtk.ImageMenuItem(stock_id=gtk.STOCK_QUIT)
	item.connect("activate", quit_menu_activate)
	menu.append(item)
	menu.show_all()
else:
	menu.append(item)
	item = gtk.ImageMenuItem(stock_id=gtk.STOCK_QUIT)
	item.connect("activate", quit_menu_activate)
	menu.append(item)
	menu.show_all()

tray = egg.trayicon.TrayIcon("TrayIcon")
box = gtk.EventBox()
pixbuf = gtk.gdk.pixbuf_new_from_file("/usr/share/compiz/logo24.png")
image = gtk.Image()
image.set_from_pixbuf(pixbuf)
box.add(image)
tray.add(box)
tray.show_all()
	
box.connect("button-press-event", callback)

start_decorator_default()

gtk.main()
